# APRS

This is an on-going repository for the Automatic Positioning Reporting System (APRS) Network 
This repo includes support for Direwolf, rtl_fm & kissutil 

This repo is split into multiple directories with 

"Cross-Band Digipeater Support"

"Simplex Digipeater Support"

"RTL-SDR RX Only IGate Support"


## Installation

You're going to need 

"rtl-sdr" https://archlinux.org/packages/extra/x86_64/rtl-sdr/ (If you plan on using an rtl-sdr)

"direwolf" https://aur.archlinux.org/packages/direwolf (IIRC "kissutil is included in this package)

"telnet" https://archlinux.org/packages/core/x86_64/inetutils/ 

## Usage

Ensure that you clone this repo into your `/home/$USER/` directory so that everything can run seamlessly

_______________

To simply run direwolf for your rigs run 

Simplex VHF: `direwolf -c /home/$USER/aprs/Simplex-Support/direwolf_VHF-APRS.conf`

Simplex UHF: `direwolf -c /home/$USER/aprs/Simplex-Support/direwolf_UHF-APRS.conf`

Simplex 10m: `direwolf -c /home/$USER/aprs/Simplex-Support/direwolf_10m-APRS.conf`

Cross-Band: `direwolf -c /home/$USER/aprs/Cross-Band_Support/direwolf_MultiBands.conf`

Everyone's setup is different, Please ensure you have checked your 

`PTT` method (If you're using an RPi your PTT method will be via the GPIO pins) 

You can find the documentation on GPIO PTT here: https://www.marcelpost.com/wiki/index.php/GPIO_pin_on_the_RPi_to_trigger_PTT

`ADEVICE` (You can find this by running `aplay -l` and `arecord -l`

_______________

If you intend on using "RTL-SDR(s)" 
You're going to want to move `aprs-1200b.service` and `aprs-9600b.service` 
from `/systemd-services/` to `/etc/system/systemd/`

To enable these as services so that they run on /BOOT/ 
Run these commands in your terminal

```
sudo systemctl enable --now aprs-1200b.service
sudo systemctl enable --now aprs-9600b.service
```

_______________

To run the RTL-SDR(s) by themselves and not as a `systemd` service simply just run 

`bash 1200b_RTL-SDR_APRS.sh` or `1200b-10m_RTL-SDR_APRS.sh` or `bash 9600b_RTL-SDR_APRS.sh`

This should give you a `print` of whats going on in your terminal window such as packets recieved

_______________


This repo also includes a method to send messages to other stations by utilizing the kissutil

In the "APRS-Messaging" directory is a shell script that you will need to edit for your station
such as 

```
USER="ab1cde"
PASS="12345" 
```
Ensure you have this correctly changed for your station 

Usage of running the script is very simple

```
bash aprs-message.sh "callsign you want to send a message to" "your message"
```

This will telnet into the APRS-IS system with your login details and first send the message over TCPIP

It will secondly send the message over RF over the KISS TNC via WIDE1-1,WIDE2-1,APRS,TCPIP


## Contributing

Pull requests are welcome. For major changes, please open an issue first
to discuss what you would like to change.

Please make sure to update tests as appropriate.

## Credits

A very special thanks goes to Emma/Everett (KX4AT)

for their amazing help putting this some of this config together,
for resparking my interest again in Packet Radio and staying up until all hours of the morning/evening answering my stupid questions

"Help! I'm trapped in a digipeater! :C (Direwolf 08.18.23)" -KX4AT-10 

## Notes

The "direwolf_UHF direwolf_VHF direwolf_10m .conf" 's include an ibeacon to "TOOT"
A Mastodon bot that posts your APRS Messages to the Fediverse Social Media platform
You can find your posts by navigating to "https://aprs.internaluse.net/@"your callsign"
This is maintained by Crossy (VK4XSS/VK3FUR) 

If you do not wish for this to occur, Please comment out the "Mastodon Beacon"

```
#-----------------#
# Mastodon Beacon #
#-----------------#
# https://aprs.internaluse.net/@{Your Callsign Here}/
# Do not attach your SSID "-#" to the end of your Callsign, Simply just your call as is :-)

IBEACON sendto=IG delay=1 every=180 via=TOOT
```
## Further Notes

After further testing sending `TOOT` 's via `IBEACON` won't work and need to be an `RF ONLY` sent packet
I'll edit the configurations later on this week (1/2/24) to make sure this is properly fixed

## FURTHER Further notes (Edited: 2/4/24)
The Mastodon beacon will not accept `IBEACON` and will only accept `RF ONLY (CBEACON)` This is something I need to speak to
VK4XSS about at some point in time whenever that will occur and have this fixed 
_______________


Currently as far as I'm aware there is no easy way to get the RTL-SDR to run at 300 baud on Sideband for HF APRS

Short of using an SDR software such as "gqrx" and piping audio into a loopback device and creating a custom config
for decoding HF packets, This is unfortunely a limitation of the RTL-SDR software

## Future development

I will try to maintain this repo as best as I can, 
I'm still working on some stuff in the background so expect changes from time to time

Until next push
Meow :3



